package admin;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;

import scg.game.PlayerProxy;
import scg.gen.PlayerSpec;
import edu.neu.ccs.demeterf.http.classes.HTTPReq;
import edu.neu.ccs.demeterf.http.classes.HTTPResp;

/** A remote proxy that implements distributed Admin/Player communication */
public class RemotePlayerProxy extends PlayerProxy {

    /** Save HTTP interactions? */
    private static java.io.PrintStream save = null;
    /** The maximum response size... should be big, or 0 */
    private long maxResponse;
    
    /** Save HTTP responses? */
    public static void setSaveFile(String file) throws IOException{
        save = new PrintStream(new FileOutputStream(file));
    }

    /** Create a proxy that sends requests over a socket to the Player */
    public RemotePlayerProxy(PlayerSpec playerSpec, long max) {
        super(playerSpec);
        maxResponse = max;
    }

    private void saveWrap(String s){
        if (save == null) {
            return;
        }
        save.println("----------------" + this.getSpec().getName() + "-------------------\n" + s
                + "\n----------------------------------------------\n");
        save.flush();
    }

    /** Send the request over the wire */
    @Override
    public HTTPResp contactPlayer(HTTPReq req, int timelimit){
        saveWrap(req.toString());
        try {
            long timeBefore = System.currentTimeMillis();
            HTTPResp resp = req.send(getSpec().getAddress(), getSpec().getPort(), timelimit * 1000, maxResponse);
            saveWrap(resp.toString());
            long timeAfter = System.currentTimeMillis();
            long duration = (timeAfter - timeBefore) / 1000;
            /** leave'em 1 more second grace */
            if (duration > timelimit + 1) {
                throw new RuntimeException(" Transaction took " + duration + "seconds.");
            }
            return resp;
        } catch (RuntimeException e) {
            throw e;
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
